Bug 852837

Summary: Dashboard shows messed metric graph on IE 8/9
Product: [Other] RHQ Project Reporter: Larry O'Leary <loleary>
Component: Core UIAssignee: Jirka Kremser <jkremser>
Status: CLOSED CURRENTRELEASE QA Contact: Mike Foley <mfoley>
Severity: high Docs Contact:
Priority: urgent    
Version: 4.4CC: ajuricic, hrupp, jkremser, loleary, mithomps
Target Milestone: ---   
Target Release: RHQ 4.5.0   
Hardware: All   
OS: Windows   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: 845277 Environment:
Last Closed: 2013-09-01 05:58:21 EDT Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On:    
Bug Blocks: 845277, 894319, 895664    

Description Larry O'Leary 2012-08-29 13:56:44 EDT
+++ This bug was initially created as a clone of JON Product Bug #845277 +++

The Metric Graphs in JBoss ON dashboard is messed/ broken on IE 8/9. It is just displaying the graph numbers. Steps to reproduce:

1. create a new dashboard (click on Dashboard menu -> New Dashboard)
2. select Resource Metric Graph or Resource Group Metric in the Add Portlet combo
3. click on the Edit icon placed in the right top corner of the new portlet
4. choose some resource (i.e Datasource) in the Resource combo (i.e. DefaultDS)
5. choose any of the available options in the Metric combo (i.e. Available Connection Count)
6. click on save button

Actual results:
The metric graphs will be broken.

Expected results:
The graphs should be displayed correctly like for firefox.

Additional info:
On Firefox, it works well.

--- Additional comment from loleary@redhat.com on 2012-08-06 11:37:54 EDT ---

Created attachment 602534 [details]
Screenshot - Broken graph on dashboard

Screen-shot showing how the broken graph looks on the Dashboard. The graph points appear to be missing and the axis labels are misplaced.

--- Additional comment from loleary@redhat.com on 2012-08-06 11:39:22 EDT ---

Created attachment 602535 [details]
Screenshot - Working graph on Monitoring > Graphs view

Screen-shot showing the same graph working on the resource's Monitoring > Graphs view tab.

--- Additional comment from loleary@redhat.com on 2012-08-06 12:03:57 EDT ---

Same issue affects both IE 8 and IE 9. Reproduced with the following versions:
    Version: 9.0.8112.16421
    Version: 8.0.6001.18702

--- Additional comment from jkremser@redhat.com on 2012-08-13 12:22:17 EDT ---

The charts use the gflot library, which internally uses the <CANVAS> element (not supported in IE8/9). Fortunately, there are some workarounds. The most promising are excanvas http://code.google.com/p/explorercanvas/ and GWTCanvas from GWT Incubator (http://code.google.com/p/google-web-toolkit-incubator/wiki/GWTCanvas). The former one is more mature.

Currently we use gflot in version 1.0.0. There is 2.4.2 version present in Maven Central. It seems like the newest version has built-in support for excanvas, but the API has been slightly modified (just some refactoring, nothing serious). So I am trying to upgrade the version of gflot,

--- Additional comment from jkremser@redhat.com on 2012-08-15 13:51:34 EDT ---

master
time:    Wed Aug 15 19:42:24 2012 +0200
commit:  5d243b30f5315f18329f6f4fa9db22ae47eb32bd
author:  Jirka Kremser - jkremser@redhat.com
message: [BZ 845277 - JBoss ON dashboard shows messed metric graph on IE 8/9] Version of gflot upgraded to 2.4.2 (it contains the excanvas library for IE8/9 support of HTML canvas el.), version of sparkline upgraded to 2.0, version of jquery upgraded to 1.7.2

--- Additional comment from jkremser@redhat.com on 2012-08-15 14:17:14 EDT ---

http://git.fedorahosted.org/cgit/rhq/rhq.git/diff/?id=5d243b3
http://git.fedorahosted.org/cgit/rhq/rhq.git/diff/?id=8000e71

master
time:    Wed Aug 15 20:13:14 2012 +0200
commit:  8000e712dd98fd8ee8e1ff52940e15b07f11e782
author:  Jirka Kremser - jkremser@redhat.com
message: [BZ 845277] - quick fix: removed the doctype declaration and removed overcasting to int

--- Additional comment from mithomps@redhat.com on 2012-08-15 15:09:25 EDT ---

I have verified the fix for IE8 and reviewed solution.
Comment 1 Larry O'Leary 2013-01-14 10:31:18 EST
Looks like 894319 was added to "Blocks" list due to this fix introducing a very bad regression.
Comment 2 Mike Thompson 2013-01-14 22:24:21 EST
Although the JON commit BZ 845277 should be reverted, this commit should not be reverted as the jquery and sparkline upgrades are a useful addition for 3.2.0. The gflot2 upgrade is fine in master and will soon be pulled for replacement by the d3 charts.
Comment 3 Heiko W. Rupp 2013-09-01 05:58:21 EDT
Bulk closing of items that are on_qa and in old RHQ releases, which are out for a long time and where the issue has not been re-opened since.